      SUBROUTINE FIT_LGNU(IUD,N,X,Y,EY,A,SGA,COV,PROB)
C Bernd Berg Dec 16 2000. 
C PROB: CONFIDENCE LEVEL FOR THE ELLIPSE.
      include '../../Libs/Fortran/implicit.sta'
      PARAMETER(NFIG=200)
      DIMENSION X(N),Y(N),EY(N), A(2),SGA(2),COV(2,2)
      DIMENSION COVDD(2),SGB(2),EIGVS(2,2)
C
C 1. REGRESSION LINE
C
      OPEN(UNIT=IUD,FILE="lfit1.d",STATUS='UNKNOWN')
      DO I=1,N
        WRITE(IUD,'(1X,4G16.7)') X(I),Y(I),EY(I)
      END DO
      CLOSE(IUD)
C
C 2. CONFIDENCE ELLIPSE:
C
      CALL EIGEN_2X2(COV,COVDD,EIGVS)
      SGB(1)=SQRT(COVDD(1))
      SGB(2)=SQRT(COVDD(2))
      CALL ELLIPSE(A,SGA,SGB,EIGVS,PROB,IUD)
C 
C 3. INCLUDE CONFIDENCE LIMITS FOR REGRESSION LINE:
C
      DELX=(X(N)-X(1))/NFIG
C
      OPEN(UNIT=IUD,FILE="lfit2.d",STATUS='UNKNOWN')
      DO I=0,NFIG
        XX=X(1)+I*DELX
        VARB1=ABS(EIGVS(1,1)+XX*EIGVS(2,1))**2*COVDD(1)
        VARB2=ABS(EIGVS(1,2)+XX*EIGVS(2,2))**2*COVDD(2)
        YM=A(1)+A(2)*XX-SQRT(VARB1+VARB2)
        YY=A(1)+A(2)*XX
        YP=A(1)+A(2)*XX+SQRT(VARB1+VARB2)
        WRITE(IUD,'(1X,4G16.7)') XX,YM,YY,YP
      END DO
      CLOSE(IUD)
C
      RETURN
      END
